Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90	(revision 2528)
@@ -2,5 +2,9 @@
    !!==============================================================================
    !!                       ***  MODULE  traldf_bilapg  ***
-   !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
+   !! Ocean  tracers:  horizontal component of the lateral tracer mixing trend
+   !!==============================================================================
+   !! History : 8.0   ! 1997-07  (G. Madec)  Original code
+   !!   NEMO    1.0   ! 2002-08  (G. Madec)  F90: Free form and module
+   !!           3.3   ! 2010-06  (C. Ethe, G. Madec) Merge TRA-TRC
    !!==============================================================================
 #if defined key_ldfslp   ||   defined key_esopa
@@ -12,21 +16,17 @@
    !!   ldfght         :  ???
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
    USE ldftra_oce      ! ocean active tracers: lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
    USE ldfslp          ! iso-neutral slopes available
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
    USE diaptr          ! poleward transport diagnostics 
-   USE prtctl          ! Print control
+   USE trc_oce         ! share passive tracers/Ocean variables
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_ldf_bilapg    ! routine called by step.F90
+   PUBLIC   tra_ldf_bilapg   ! routine called by step.F90
 
    !! * Substitutions
@@ -35,16 +35,15 @@
 #  include "ldfeiv_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-   
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE tra_ldf_bilapg( kt )
+   SUBROUTINE tra_ldf_bilapg( kt, cdtype, ptb, pta, kjpt )
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE tra_ldf_bilapg  ***
       !!                    
-      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
+      !! ** Purpose :   Compute the before horizontal tracer diffusive 
       !!      trend and add it to the general trend of tracer equation.
       !!
@@ -54,84 +53,67 @@
       !!      computed in routine inildf.
       !!         -1- compute the geopotential harmonic operator applied to
-      !!      (tb,sb) and multiply it by the eddy diffusivity coefficient
-      !!      (done by a call to ldfght routine, result in (wk1,wk2) arrays).
+      !!        ptb and multiply it by the eddy diffusivity coefficient
+      !!       (done by a call to ldfght routine, result in wk1 arrays).
       !!      Applied the domain lateral boundary conditions by call to lbc_lnk
       !!         -2- compute the geopotential harmonic operator applied to
-      !!      (wk1,wk2) by a second call to ldfght routine (result in (wk3,wk4)
+      !!      wk1 by a second call to ldfght routine (result in wk2)
       !!      arrays).
-      !!         -3- Add this trend to the general trend (ta,sa):
-      !!            (ta,sa) = (ta,sa) + (wk3,wk4)
-      !!
-      !! ** Action : - Update (ta,sa) arrays with the before geopotential 
+      !!         -3- Add this trend to the general trend 
+      !!            pta = pta + wk2
+      !!
+      !! ** Action : - Update pta arrays with the before geopotential 
       !!               biharmonic mixing trend.
-      !!
-      !! History :
-      !!   8.0  !  97-07  (G. Madec)  Original code
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce           , wk1 => ua,  &  ! use ua as workspace
-         &                wk2 => va      ! use va as workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt           ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk                 ! dummy loop indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         wk3, wk4                ! work array used for rotated biharmonic
-         !                       ! operator on tracers and/or momentum
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 ) THEN
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in   )                      ::   kt       ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                      ::   cdtype   ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                      ::   kjpt     ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb      ! before and now tracer fields
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta      ! tracer trend 
+      !!
+      INTEGER ::   ji, jj, jk, jn                 ! dummy loop indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt) ::   wk1, wk2   ! 4D workspace
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_bilapg : horizontal biharmonic operator in s-coordinate'
+         IF(lwp) WRITE(numout,*) 'tra_ldf_bilapg : horizontal biharmonic operator in s-coordinate on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~'
       ENDIF
 
-      ! 1. Laplacian of (tb,sb) * aht
+      ! 1. Laplacian of ptb * aht
       ! ----------------------------- 
-      ! rotated harmonic operator applied to (tb,sb)
-      ! and multiply by aht (output in (wk1,wk2) )
-
-      CALL ldfght ( kt, tb, sb, wk1, wk2, 1 )
-
-
-      ! Lateral boundary conditions on (wk1,wk2)   (unchanged sign)
-      CALL lbc_lnk( wk1, 'T', 1. )   ;   CALL lbc_lnk( wk2, 'T', 1. )
-
-      ! 2. Bilaplacian of (tb,sb)
+      CALL ldfght( kt, cdtype, ptb, wk1, kjpt, 1 )      ! rotated harmonic operator applied to ptb and multiply by aht 
+      !                                                 ! output in wk1 
+      !
+      DO jn = 1, kjpt
+         CALL lbc_lnk( wk1(:,:,:,jn) , 'T', 1. )        ! Lateral boundary conditions on wk1   (unchanged sign)
+      END DO
+
+      ! 2. Bilaplacian of ptb
       ! -------------------------
-      ! rotated harmonic operator applied to (wk1,wk2)
-      ! (output in (wk3,wk4) )
-
-      CALL ldfght ( kt, wk1, wk2, wk3, wk4, 2 )
+      CALL ldfght( kt, cdtype, wk1, wk2, kjpt, 2 )      ! rotated harmonic operator applied to wk1 ; output in wk2
 
 
       ! 3. Update the tracer trends                    (j-slab :   2, jpj-1)
       ! ---------------------------
-      !                                                ! ===============
-      DO jj = 2, jpjm1                                 !  Vertical slab
-         !                                             ! ===============
-         DO jk = 1, jpkm1
-            DO ji = 2, jpim1
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + wk3(ji,jj,jk)
-               sa(ji,jj,jk) = sa(ji,jj,jk) + wk4(ji,jj,jk)
+      DO jn = 1, kjpt
+         DO jj = 2, jpjm1
+            DO jk = 1, jpkm1
+               DO ji = 2, jpim1
+                  ! add it to the general tracer trends
+                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + wk2(ji,jj,jk,jn)
+               END DO
             END DO
          END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-
+      END DO
+      !
    END SUBROUTINE tra_ldf_bilapg
 
 
-   SUBROUTINE ldfght ( kt, pt, ps, plt, pls, kaht )
+   SUBROUTINE ldfght ( kt, cdtype, pt, plt, kjpt, kaht )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE ldfght  ***
       !!          
-      !! ** Purpose :   Apply a geopotential harmonic operator to (pt,ps) and 
+      !! ** Purpose :   Apply a geopotential harmonic operator to (pt) and 
       !!      multiply it by the eddy diffusivity coefficient (if kaht=1).
       !!      Routine only used in s-coordinates (l_sco=T) with bilaplacian
@@ -140,5 +122,5 @@
       !!
       !! ** Method  :   The harmonic operator rotated along geopotential 
-      !!      surfaces is applied to (pt,ps) using the slopes of geopotential
+      !!      surfaces is applied to (pt) using the slopes of geopotential
       !!      surfaces computed in inildf routine. The result is provided in
       !!      (plt,pls) arrays. It is computed in 2 steps:
@@ -166,224 +148,177 @@
       !!         plt  =  1  / (e1t*e2t*e3t) { plt + dk[ zftw ] }
       !!
-      !! * Action :
-      !!      'key_trdtra' defined: the trend is saved for diagnostics.
-      !!
-      !! History :
-      !!   8.0  !  97-07  (G. Madec)  Original code
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt           ! ocean time-step index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in  ) ::   &
-         pt, ps           ! tracer fields (before t and s for 1st call
-      !                   ! and laplacian of these fields for 2nd call.
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( out ) ::   &
-         plt, pls         ! partial harmonic operator applied to
-      !                   ! pt & ps components except
-      !                   ! second order vertical derivative term)
-      INTEGER, INTENT( in ) ::   &
-         kaht             ! =1 multiply the laplacian by the eddy diffusivity coeff.
-      !                   ! =2 no multiplication
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk             ! dummy loop indices
-      REAL(wp) ::   &
-         zabe1, zabe2, zmku, zmkv,     &  ! temporary scalars
-         zbtr, ztah, zsah, ztav, zsav, &
-         zcof0, zcof1, zcof2,          &
-         zcof3, zcof4
-      REAL(wp), DIMENSION(jpi,jpj) ::  &
-         zftu, zfsu,                   &  ! workspace
-         zdkt, zdk1t,                  &
-         zdks, zdk1s
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zftv, zfsv                       ! workspace (only v components for ptr)
-      REAL(wp), DIMENSION(jpi,jpk) ::  &
-         zftw, zfsw,                   &  ! workspace
-         zdit, zdjt, zdj1t,            &
-         zdis, zdjs, zdj1s
-      !!----------------------------------------------------------------------
-
-      !                               ! ********** !   ! ===============
-      DO jk = 1, jpkm1                ! First step !   ! Horizontal slab
-         !                            ! ********** !   ! ===============
-
-         ! I.1 Vertical gradient of pt and ps at level jk and jk+1
-         ! -------------------------------------------------------
-         !     surface boundary condition: zdkt(jk=1)=zdkt(jk=2)
-
-         zdk1t(:,:) = ( pt(:,:,jk) - pt(:,:,jk+1) ) * tmask(:,:,jk+1)
-         zdk1s(:,:) = ( ps(:,:,jk) - ps(:,:,jk+1) ) * tmask(:,:,jk+1)
-
-         IF( jk == 1 ) THEN
-            zdkt(:,:) = zdk1t(:,:)
-            zdks(:,:) = zdk1s(:,:)
-         ELSE
-            zdkt(:,:) = ( pt(:,:,jk-1) - pt(:,:,jk) ) * tmask(:,:,jk)
-            zdks(:,:) = ( ps(:,:,jk-1) - ps(:,:,jk) ) * tmask(:,:,jk)
+      !!----------------------------------------------------------------------
+      USE oce         , zftv => ua     ! use ua as workspace
+      !!
+      INTEGER         , INTENT(in )                              ::  kt      ! ocean time-step index
+      CHARACTER(len=3), INTENT(in )                              ::  cdtype  ! =TRA or TRC (tracer indicator) 
+      INTEGER         , INTENT(in )                              ::  kjpt    !: dimension of 
+      REAL(wp)        , INTENT(in ), DIMENSION(jpi,jpj,jpk,kjpt) ::  pt      ! tracer fields ( before for 1st call
+      !                                                         ! and laplacian of these fields for 2nd call. 
+      REAL(wp)        , INTENT(out), DIMENSION(jpi,jpj,jpk,kjpt) ::  plt     !: partial harmonic operator applied to  pt  components except
+      !                                                             !: second order vertical derivative term  
+      INTEGER         , INTENT(in )                              ::  kaht    !: =1 multiply the laplacian by the eddy diffusivity coeff.
+      !                                                             !: =2 no multiplication 
+      !!
+      INTEGER ::   ji, jj, jk,jn          ! dummy loop indices
+      !                                   ! temporary scalars
+      REAL(wp) ::  zabe1, zabe2, zmku, zmkv 
+      REAL(wp) ::  zbtr, ztah, ztav
+      REAL(wp) ::  zcof0, zcof1, zcof2, zcof3, zcof4
+      REAL(wp), DIMENSION(jpi,jpj) ::  zftu,  zdkt, zdk1t       ! workspace
+      REAL(wp), DIMENSION(jpi,jpk) ::  zftw, zdit, zdjt, zdj1t  ! 
+      !!----------------------------------------------------------------------
+
+      !
+      DO jn = 1, kjpt
+         !                               ! ********** !   ! ===============
+         DO jk = 1, jpkm1                ! First step !   ! Horizontal slab
+            !                            ! ********** !   ! ===============
+            
+            ! I.1 Vertical gradient of pt and ps at level jk and jk+1
+            ! -------------------------------------------------------
+            !     surface boundary condition: zdkt(jk=1)=zdkt(jk=2)
+            
+            zdk1t(:,:) = ( pt(:,:,jk,jn) - pt(:,:,jk+1,jn) ) * tmask(:,:,jk+1)
+            IF( jk == 1 ) THEN
+               zdkt(:,:) = zdk1t(:,:)
+            ELSE
+               zdkt(:,:) = ( pt(:,:,jk-1,jn) - pt(:,:,jk,jn) ) * tmask(:,:,jk)
+            ENDIF
+
+
+            ! I.2 Horizontal fluxes
+            ! ---------------------
+            
+            DO jj = 1, jpjm1
+               DO ji = 1, jpim1
+                  zabe1 = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj)
+                  zabe2 = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj)
+                  
+                  zmku = 1./MAX( tmask(ji+1,jj,jk  )+tmask(ji,jj,jk+1)   &
+                     &          +tmask(ji+1,jj,jk+1)+tmask(ji,jj,jk  ),1. )
+                  zmkv = 1./MAX( tmask(ji,jj+1,jk  )+tmask(ji,jj,jk+1)   &
+                     &          +tmask(ji,jj+1,jk+1)+tmask(ji,jj,jk  ),1. )
+                  
+                  zcof1 = -e2u(ji,jj) * uslp(ji,jj,jk) * zmku
+                  zcof2 = -e1v(ji,jj) * vslp(ji,jj,jk) * zmkv
+                  
+                  zftu(ji,jj)= umask(ji,jj,jk) *   &
+                     &         (  zabe1 *( pt   (ji+1,jj,jk,jn) - pt(ji,jj,jk,jn) )   &
+                     &          + zcof1 *( zdkt (ji+1,jj) + zdk1t(ji,jj)     &
+                     &                    +zdk1t(ji+1,jj) + zdkt (ji,jj) )  )
+                  
+                  zftv(ji,jj,jk)= vmask(ji,jj,jk) *   &
+                     &         (  zabe2 *( pt(ji,jj+1,jk,jn) - pt(ji,jj,jk,jn) )   &
+                     &          + zcof2 *( zdkt (ji,jj+1) + zdk1t(ji,jj)     &
+                     &                    +zdk1t(ji,jj+1) + zdkt (ji,jj) )  )                  
+               END DO
+            END DO
+
+
+            ! I.3 Second derivative (divergence) (not divided by the volume)
+            ! ---------------------
+            
+            DO jj = 2 , jpjm1
+               DO ji = 2 , jpim1
+                  ztah = zftu(ji,jj) - zftu(ji-1,jj) + zftv(ji,jj,jk) - zftv(ji,jj-1,jk)
+                  plt(ji,jj,jk,jn) = ztah
+               END DO
+            END DO
+            !                                             ! ===============
+         END DO                                           !   End of slab
+         !                                                ! ===============
+         ! "Poleward" diffusive heat or salt transport
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( kaht == 2 ) .AND. ( MOD( kt, nn_fptr ) == 0 ) ) THEN
+            IF( jn == jp_tem)   htr_ldf(:) = ptr_vj( zftv(:,:,:) )
+            IF( jn == jp_sal)   str_ldf(:) = ptr_vj( zftv(:,:,:) )
          ENDIF
 
-
-         ! I.2 Horizontal fluxes
-         ! ---------------------
-
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1
-               zabe1 = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj)
-               zabe2 = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj)
-
-               zmku=1./MAX( tmask(ji+1,jj,jk  )+tmask(ji,jj,jk+1)   &
-                           +tmask(ji+1,jj,jk+1)+tmask(ji,jj,jk  ),1. )
-               zmkv=1./MAX( tmask(ji,jj+1,jk  )+tmask(ji,jj,jk+1)   &
-                           +tmask(ji,jj+1,jk+1)+tmask(ji,jj,jk  ),1. )
-
-               zcof1= -e2u(ji,jj) * uslp(ji,jj,jk) * zmku
-               zcof2= -e1v(ji,jj) * vslp(ji,jj,jk) * zmkv
-
-               zftu(ji,jj)= umask(ji,jj,jk) *   &
-                  (  zabe1 *( pt(ji+1,jj,jk) - pt(ji,jj,jk) )   &
-                   + zcof1 *( zdkt (ji+1,jj) + zdk1t(ji,jj)     &
-                             +zdk1t(ji+1,jj) + zdkt (ji,jj) )  )
-
-               zftv(ji,jj,jk)= vmask(ji,jj,jk) *   &
-                  (  zabe2 *( pt(ji,jj+1,jk) - pt(ji,jj,jk) )   &
-                   + zcof2 *( zdkt (ji,jj+1) + zdk1t(ji,jj)     &
-                             +zdk1t(ji,jj+1) + zdkt (ji,jj) )  )
-
-               zfsu(ji,jj)= umask(ji,jj,jk) *   &
-                  (  zabe1 *( ps(ji+1,jj,jk) - ps(ji,jj,jk) )   &
-                   + zcof1 *( zdks (ji+1,jj) + zdk1s(ji,jj)     &
-                             +zdk1s(ji+1,jj) + zdks (ji,jj) )  )
-
-               zfsv(ji,jj,jk)= vmask(ji,jj,jk) *   &
-                  (  zabe2 *( ps(ji,jj+1,jk) - ps(ji,jj,jk) )   &
-                   + zcof2 *( zdks (ji,jj+1) + zdk1s(ji,jj)     &
-                             +zdk1s(ji,jj+1) + zdks (ji,jj) )  )
-            END DO
-         END DO
-
-
-         ! I.3 Second derivative (divergence) (not divided by the volume)
-         ! ---------------------
-
-         DO jj = 2 , jpjm1
-            DO ji = 2 , jpim1
-               ztah = zftu(ji,jj) - zftu(ji-1,jj) + zftv(ji,jj,jk) - zftv(ji,jj-1,jk)
-               zsah = zfsu(ji,jj) - zfsu(ji-1,jj) + zfsv(ji,jj,jk) - zfsv(ji,jj-1,jk)
-               plt(ji,jj,jk) = ztah
-               pls(ji,jj,jk) = zsah
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
- 
-      !!but this should be done somewhere after 
-      ! "zonal" mean diffusive heat and salt transport
-      IF( ln_diaptr .AND. ( kaht == 2 ) .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         pht_ldf(:) = ptr_vj( zftv(:,:,:) )
-         pst_ldf(:) = ptr_vj( zfsv(:,:,:) )
-      ENDIF
-
-      !                             ! ************ !   ! ===============
-      DO jj = 2, jpjm1              !  Second step !   ! Horizontal slab
-         !                          ! ************ !   ! ===============
-
-         ! II.1 horizontal tracer gradient
-         ! -------------------------------
-
-         DO jk = 1, jpk
-            DO ji = 1, jpim1
-               zdit (ji,jk) = ( pt(ji+1,jj  ,jk) - pt(ji,jj  ,jk) ) * umask(ji,jj  ,jk)
-               zdis (ji,jk) = ( ps(ji+1,jj  ,jk) - ps(ji,jj  ,jk) ) * umask(ji,jj  ,jk)
-               zdjt (ji,jk) = ( pt(ji  ,jj+1,jk) - pt(ji,jj  ,jk) ) * vmask(ji,jj  ,jk)
-               zdjs (ji,jk) = ( ps(ji  ,jj+1,jk) - ps(ji,jj  ,jk) ) * vmask(ji,jj  ,jk)
-               zdj1t(ji,jk) = ( pt(ji  ,jj  ,jk) - pt(ji,jj-1,jk) ) * vmask(ji,jj-1,jk)
-               zdj1s(ji,jk) = ( ps(ji  ,jj  ,jk) - ps(ji,jj-1,jk) ) * vmask(ji,jj-1,jk)
-            END DO
-         END DO
-
-
-         ! II.2 Vertical fluxes
-         ! --------------------
-
-         ! Surface and bottom vertical fluxes set to zero
-         zftw(:, 1 ) = 0.e0
-         zfsw(:, 1 ) = 0.e0
-         zftw(:,jpk) = 0.e0
-         zfsw(:,jpk) = 0.e0
-
-         ! interior (2=<jk=<jpk-1)
-         DO jk = 2, jpkm1
-            DO ji = 2, jpim1
-               zcof0 = e1t(ji,jj) * e2t(ji,jj) / fse3w(ji,jj,jk)   &
-                     * (  wslpi(ji,jj,jk) * wslpi(ji,jj,jk)        &
-                        + wslpj(ji,jj,jk) * wslpj(ji,jj,jk)  )
-
-               zmku =1./MAX(  umask(ji  ,jj,jk-1)+umask(ji-1,jj,jk)   &
-                             +umask(ji-1,jj,jk-1)+umask(ji  ,jj,jk), 1. )
-
-               zmkv =1./MAX(  vmask(ji,jj  ,jk-1)+vmask(ji,jj-1,jk)   &
-                             +vmask(ji,jj-1,jk-1)+vmask(ji,jj  ,jk), 1. )
-
-               zcof3 = - e2t(ji,jj) * wslpi (ji,jj,jk) * zmku
-               zcof4 = - e1t(ji,jj) * wslpj (ji,jj,jk) * zmkv
-
-               zftw(ji,jk) = tmask(ji,jj,jk) *   &
-                  (  zcof0 * ( pt  (ji,jj,jk-1) - pt  (ji,jj,jk) )   &
-                   + zcof3 * ( zdit (ji  ,jk-1) + zdit (ji-1,jk)     &
-                              +zdit (ji-1,jk-1) + zdit (ji  ,jk) )   &
-                   + zcof4 * ( zdjt (ji  ,jk-1) + zdj1t(ji  ,jk)     &
-                              +zdj1t(ji  ,jk-1) + zdjt (ji  ,jk) )  )
-
-               zfsw(ji,jk) = tmask(ji,jj,jk) *   &
-                  (  zcof0 * ( ps  (ji,jj,jk-1) - ps  (ji,jj,jk) )   &
-                   + zcof3 * ( zdis (ji  ,jk-1) + zdis (ji-1,jk)     &
-                              +zdis (ji-1,jk-1) + zdis (ji  ,jk) )   &
-                   + zcof4 * ( zdjs (ji  ,jk-1) + zdj1s(ji  ,jk)     &
-                              +zdj1s(ji  ,jk-1) + zdjs (ji  ,jk) )  )
-            END DO
-         END DO
-
-
-         ! II.3 Divergence of vertical fluxes added to the horizontal divergence
-         ! ---------------------------------------------------------------------
-
-         IF( kaht == 1 ) THEN
-            ! multiply the laplacian by the eddy diffusivity coefficient
-            DO jk = 1, jpkm1
+         !                             ! ************ !   ! ===============
+         DO jj = 2, jpjm1              !  Second step !   ! Horizontal slab
+            !                          ! ************ !   ! ===============
+            
+            ! II.1 horizontal tracer gradient
+            ! -------------------------------
+            
+            DO jk = 1, jpk
+               DO ji = 1, jpim1
+                  zdit (ji,jk) = ( pt(ji+1,jj  ,jk,jn) - pt(ji,jj  ,jk,jn) ) * umask(ji,jj  ,jk)
+                  zdjt (ji,jk) = ( pt(ji  ,jj+1,jk,jn) - pt(ji,jj  ,jk,jn) ) * vmask(ji,jj  ,jk)
+                  zdj1t(ji,jk) = ( pt(ji  ,jj  ,jk,jn) - pt(ji,jj-1,jk,jn) ) * vmask(ji,jj-1,jk)
+               END DO
+            END DO
+
+
+            ! II.2 Vertical fluxes
+            ! --------------------
+            
+            ! Surface and bottom vertical fluxes set to zero
+            zftw(:, 1 ) = 0.e0
+            zftw(:,jpk) = 0.e0
+            
+            ! interior (2=<jk=<jpk-1)
+            DO jk = 2, jpkm1
                DO ji = 2, jpim1
-                  ! eddy coef. divided by the volume element
-                  zbtr = fsahtt(ji,jj,jk) / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
-                  ! vertical divergence
-                  ztav = zftw(ji,jk) - zftw(ji,jk+1)
-                  zsav = zfsw(ji,jk) - zfsw(ji,jk+1)
-                  ! harmonic operator applied to (pt,ps) and multiply by aht
-                  plt(ji,jj,jk) = ( plt(ji,jj,jk) + ztav ) * zbtr
-                  pls(ji,jj,jk) = ( pls(ji,jj,jk) + zsav ) * zbtr
-               END DO
-            END DO
-         ELSEIF( kaht == 2 ) THEN
-            ! second call, no multiplication
-            DO jk = 1, jpkm1
-               DO ji = 2, jpim1
-                  ! inverse of the volume element
-                  zbtr = 1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
-                  ! vertical divergence
-                  ztav = zftw(ji,jk) - zftw(ji,jk+1)
-                  zsav = zfsw(ji,jk) - zfsw(ji,jk+1)
-                  ! harmonic operator applied to (pt,ps) 
-                  plt(ji,jj,jk) = ( plt(ji,jj,jk) + ztav ) * zbtr
-                  pls(ji,jj,jk) = ( pls(ji,jj,jk) + zsav ) * zbtr
-               END DO
-            END DO
-         ELSE
-            IF(lwp) WRITE(numout,*) ' ldfght: kaht= 1 or 2, here =', kaht
-            IF(lwp) WRITE(numout,*) '         We stop'
-            STOP 'ldfght'
-         ENDIF
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
+                  zcof0 = e1t(ji,jj) * e2t(ji,jj) / fse3w(ji,jj,jk)   &
+                     &     * (  wslpi(ji,jj,jk) * wslpi(ji,jj,jk)        &
+                     &        + wslpj(ji,jj,jk) * wslpj(ji,jj,jk)  )
+                  
+                  zmku = 1./MAX(  umask(ji  ,jj,jk-1)+umask(ji-1,jj,jk)   &
+                     &           +umask(ji-1,jj,jk-1)+umask(ji  ,jj,jk), 1. )
+                  
+                  zmkv = 1./MAX(  vmask(ji,jj  ,jk-1)+vmask(ji,jj-1,jk)   &
+                     &           +vmask(ji,jj-1,jk-1)+vmask(ji,jj  ,jk), 1. )
+                  
+                  zcof3 = - e2t(ji,jj) * wslpi (ji,jj,jk) * zmku
+                  zcof4 = - e1t(ji,jj) * wslpj (ji,jj,jk) * zmkv
+                  
+                  zftw(ji,jk) = tmask(ji,jj,jk) *   &
+                     &    (  zcof0 * ( pt   (ji,jj,jk-1,jn) - pt   (ji  ,jj,jk,jn) )   &
+                     &     + zcof3 * ( zdit (ji   ,jk-1   ) + zdit (ji-1,jk      )     &
+                     &                +zdit (ji-1 ,jk-1   ) + zdit (ji  ,jk      ) )   &
+                     &     + zcof4 * ( zdjt (ji   ,jk-1   ) + zdj1t(ji  ,jk)     &
+                     &                +zdj1t(ji   ,jk-1   ) + zdjt (ji  ,jk      ) )  )                 
+               END DO
+            END DO
+
+
+            ! II.3 Divergence of vertical fluxes added to the horizontal divergence
+            ! ---------------------------------------------------------------------
+            
+            IF( kaht == 1 ) THEN
+               ! multiply the laplacian by the eddy diffusivity coefficient
+               DO jk = 1, jpkm1
+                  DO ji = 2, jpim1
+                     ! eddy coef. divided by the volume element
+                     zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     ! vertical divergence
+                     ztav = fsahtt(ji,jj,jk) * ( zftw(ji,jk) - zftw(ji,jk+1) )
+                     ! harmonic operator applied to (pt,ps) and multiply by aht
+                     plt(ji,jj,jk,jn) = ( plt(ji,jj,jk,jn) + ztav ) * zbtr
+                  END DO
+               END DO
+            ELSEIF( kaht == 2 ) THEN
+               ! second call, no multiplication
+               DO jk = 1, jpkm1
+                  DO ji = 2, jpim1
+                     ! inverse of the volume element
+                     zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     ! vertical divergence
+                     ztav = zftw(ji,jk) - zftw(ji,jk+1)
+                     ! harmonic operator applied to (pt,ps) 
+                     plt(ji,jj,jk,jn) = ( plt(ji,jj,jk,jn) + ztav ) * zbtr
+                  END DO
+               END DO
+            ELSE
+               IF(lwp) WRITE(numout,*) ' ldfght: kaht= 1 or 2, here =', kaht
+               IF(lwp) WRITE(numout,*) '         We stop'
+               STOP 'ldfght'
+            ENDIF
+            !                                             ! ===============
+         END DO                                           !   End of slab
+         !                                                ! ===============
+      END DO
+      !
    END SUBROUTINE ldfght
 
@@ -393,6 +328,8 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE tra_ldf_bilapg( kt )               ! Dummy routine
-      WRITE(*,*) 'tra_ldf_bilapg: You should not have seen this print! error?', kt
+   SUBROUTINE tra_ldf_bilapg( kt, cdtype, ptb, pta, kjpt )      ! Empty routine
+      CHARACTER(len=3) ::   cdtype
+      REAL, DIMENSION(:,:,:,:) ::   ptb, pta
+      WRITE(*,*) 'tra_ldf_iso: You should not have seen this print! error?', kt, cdtype, ptb(1,1,1,1), pta(1,1,1,1), kjpt
    END SUBROUTINE tra_ldf_bilapg
 #endif
